diff --git a/5.3/fpm/alpine/Dockerfile b/5.3/fpm/alpine/Dockerfile
new file mode 100644
index 000000000..0d025691b
--- /dev/null
+++ b/5.3/fpm/alpine/Dockerfile
@@ -0,0 +1,197 @@
+#
+# NOTE: THIS DOCKERFILE IS GENERATED VIA "update.sh"
+#
+# PLEASE DO NOT EDIT IT DIRECTLY.
+#
+
+FROM alpine:3.6
+
+# persistent / runtime deps
+ENV PHPIZE_DEPS \
+ autoconf \
+ dpkg-dev dpkg \
+ file \
+ g++ \
+ gcc \
+ libc-dev \
+ make \
+ pcre-dev \
+ pkgconf \
+ re2c
+RUN apk add --no-cache --virtual .persistent-deps \
+ ca-certificates \
+ curl \
+ tar \
+ xz
+
+# ensure www-data user exists
+RUN set -x \
+ && addgroup -g 82 -S www-data \
+ && adduser -u 82 -D -S -G www-data www-data
+# 82 is the standard uid/gid for "www-data" in Alpine
+# http://git.alpinelinux.org/cgit/aports/tree/main/apache2/apache2.pre-install?h=v3.3.2
+# http://git.alpinelinux.org/cgit/aports/tree/main/lighttpd/lighttpd.pre-install?h=v3.3.2
+# http://git.alpinelinux.org/cgit/aports/tree/main/nginx-initscripts/nginx-initscripts.pre-install?h=v3.3.2
+
+ENV PHP_INI_DIR /usr/local/etc/php
+RUN mkdir -p $PHP_INI_DIR/conf.d
+
+####
+ENV PHP_EXTRA_CONFIGURE_ARGS --enable-fpm --with-fpm-user=www-data --with-fpm-group=www-data
+####
+
+# Apply stack smash protection to functions using local buffers and alloca()
+# Make PHP's main executable position-independent (improves ASLR security mechanism, and has no performance impact on x86_64)
+# Enable optimization (-O2)
+# Enable linker optimization (this sorts the hash buckets to improve cache locality, and is non-default)
+# Adds GNU HASH segments to generated executables (this is used if present, and is much faster than sysv hash; in this configuration, sysv hash is also generated)
+# https://github.com/docker-library/php/issues/272
+ENV PHP_CFLAGS="-fstack-protector-strong -fpic -fpie -O2"
+ENV PHP_CPPFLAGS="$PHP_CFLAGS"
+ENV PHP_LDFLAGS="-Wl,-O1 -Wl,--hash-style=both -pie"
+
+ENV GPG_KEYS 0B96609E270F565C13292B24C13C70B87267B52D 0A95E9A026542D53835E3F3A7DEC4E69FC9C83D7 0E604491
+
+ENV PHP_VERSION 5.3.29
+ENV PHP_URL="https://secure.php.net/get/php-5.3.29.tar.xz/from/this/mirror" PHP_ASC_URL="https://secure.php.net/get/php-5.3.29.tar.xz.asc/from/this/mirror"
+ENV PHP_SHA256="8438c2f14ab8f3d6cd2495aa37de7b559e33b610f9ab264f0c61b531bf0c262d" PHP_MD5="dcff9c881fe436708c141cfc56358075"
+
+RUN set -xe; \
+ \
+ apk add --no-cache --virtual .fetch-deps \
+ gnupg \
+ libressl \
+ ; \
+ \
+ mkdir -p /usr/src; \
+ cd /usr/src; \
+ \
+ wget -O php.tar.xz "$PHP_URL"; \
+ \
+ if [ -n "$PHP_SHA256" ]; then \
+ echo "$PHP_SHA256 *php.tar.xz" | sha256sum -c -; \
+ fi; \
+ if [ -n "$PHP_MD5" ]; then \
+ echo "$PHP_MD5 *php.tar.xz" | md5sum -c -; \
+ fi; \
+ \
+ if [ -n "$PHP_ASC_URL" ]; then \
+ wget -O php.tar.xz.asc "$PHP_ASC_URL"; \
+ export GNUPGHOME="$(mktemp -d)"; \
+ for key in $GPG_KEYS; do \
+ gpg --keyserver ha.pool.sks-keyservers.net --recv-keys "$key"; \
+ done; \
+ gpg --batch --verify php.tar.xz.asc php.tar.xz; \
+ rm -r "$GNUPGHOME"; \
+ fi; \
+ \
+ apk del .fetch-deps
+
+COPY docker-php-source /usr/local/bin/
+
+RUN set -xe \
+ && apk add --no-cache --virtual .build-deps \
+ $PHPIZE_DEPS \
+ coreutils \
+ curl-dev \
+ libedit-dev \
+ libxml2-dev \
+ libressl-dev \
+ sqlite-dev \
+ \
+ && export CFLAGS="$PHP_CFLAGS" \
+ CPPFLAGS="$PHP_CPPFLAGS" \
+ LDFLAGS="$PHP_LDFLAGS" \
+ && docker-php-source extract \
+ && cd /usr/src/php \
+ && gnuArch="$(dpkg-architecture --query DEB_BUILD_GNU_TYPE)" \
+ && ./configure \
+ --build="$gnuArch" \
+ --with-config-file-path="$PHP_INI_DIR" \
+ --with-config-file-scan-dir="$PHP_INI_DIR/conf.d" \
+ \
+ --disable-cgi \
+ \
+# --enable-ftp is included here because ftp_ssl_connect() needs ftp to be compiled statically (see https://github.com/docker-library/php/issues/236)
+ --enable-ftp \
+# --enable-mbstring is included here because otherwise there's no way to get pecl to use it properly (see https://github.com/docker-library/php/issues/195)
+ --enable-mbstring \
+# --enable-mysqlnd is included here because it's harder to compile after the fact than extensions are (since it's a plugin for several extensions, not an extension in itself)
+ --enable-mysqlnd \
+ \
+ --with-curl \
+ --with-libedit \
+ --with-openssl \
+ --with-zlib \
+ \
+# bundled pcre is too old for s390x (which isn't exactly a good sign)
+# /usr/src/php/ext/pcre/pcrelib/pcre_jit_compile.c:65:2: error: #error Unsupported architecture
+ --with-pcre-regex=/usr \
+ \
+ $PHP_EXTRA_CONFIGURE_ARGS \
+ && make -j "$(nproc)" \
+ && make install \
+ && { find /usr/local/bin /usr/local/sbin -type f -perm +0111 -exec strip --strip-all '{}' + || true; } \
+ && make clean \
+ && cd / \
+ && docker-php-source delete \
+ \
+ && runDeps="$( \
+ scanelf --needed --nobanner --recursive /usr/local \
+ | awk '{ gsub(/,/, "\nso:", $2); print "so:" $2 }' \
+ | sort -u \
+ | xargs -r apk info --installed \
+ | sort -u \
+ )" \
+ && apk add --no-cache --virtual .php-rundeps $runDeps \
+ \
+ && apk del .build-deps \
+ \
+# https://github.com/docker-library/php/issues/443
+ && pecl update-channels \
+ && rm -rf /tmp/pear ~/.pearrc
+
+COPY docker-php-ext-* docker-php-entrypoint /usr/local/bin/
+
+ENTRYPOINT ["docker-php-entrypoint"]
+####
+WORKDIR /var/www/html
+
+RUN set -ex \
+ && cd /usr/local/etc \
+ && if [ -d php-fpm.d ]; then \
+ # for some reason, upstream's php-fpm.conf.default has "include=NONE/etc/php-fpm.d/*.conf"
+ sed 's!=NONE/!=!g' php-fpm.conf.default | tee php-fpm.conf > /dev/null; \
+ cp php-fpm.d/www.conf.default php-fpm.d/www.conf; \
+ else \
+ # PHP 5.x doesn't use "include=" by default, so we'll create our own simple config that mimics PHP 7+ for consistency
+ mkdir php-fpm.d; \
+ cp php-fpm.conf.default php-fpm.d/www.conf; \
+ { \
+ echo '[global]'; \
+ echo 'include=etc/php-fpm.d/*.conf'; \
+ } | tee php-fpm.conf; \
+ fi \
+ && { \
+ echo '[global]'; \
+ echo 'error_log = /proc/self/fd/2'; \
+ echo; \
+ echo '[www]'; \
+ echo '; if we send this to /proc/self/fd/1, it never appears'; \
+ echo 'access.log = /proc/self/fd/2'; \
+ echo; \
+ echo '; Ensure worker stdout and stderr are sent to the main error log.'; \
+ echo 'catch_workers_output = yes'; \
+ } | tee php-fpm.d/docker.conf \
+ && { \
+ echo '[global]'; \
+ echo 'daemonize = no'; \
+ echo; \
+ echo '[www]'; \
+ echo 'listen = 0.0.0.0:9000'; \
+ } | tee php-fpm.d/zz-docker.conf \
+ && sed -i '/listen = 127.0.0.1:9000/d' php-fpm.d/www.conf
+
+EXPOSE 9000
+CMD ["php-fpm"]
+####
diff --git a/5.3/fpm/alpine/docker-php-entrypoint b/5.3/fpm/alpine/docker-php-entrypoint
new file mode 100755
index 000000000..86343d803
--- /dev/null
+++ b/5.3/fpm/alpine/docker-php-entrypoint
@@ -0,0 +1,9 @@
+#!/bin/sh
+set -e
+
+# first arg is `-f` or `--some-option`
+if [ "${1#-}" != "$1" ]; then
+ set -- php-fpm "$@"
+fi
+
+exec "$@"
diff --git a/5.3/fpm/alpine/docker-php-ext-configure b/5.3/fpm/alpine/docker-php-ext-configure
new file mode 100755
index 000000000..375afd408
--- /dev/null
+++ b/5.3/fpm/alpine/docker-php-ext-configure
@@ -0,0 +1,63 @@
+#!/bin/sh
+set -e
+
+# prefer user supplied CFLAGS, but default to our PHP_CFLAGS
+: ${CFLAGS:=$PHP_CFLAGS}
+: ${CPPFLAGS:=$PHP_CPPFLAGS}
+: ${LDFLAGS:=$PHP_LDFLAGS}
+export CFLAGS CPPFLAGS LDFLAGS
+
+srcExists=
+if [ -d /usr/src/php ]; then
+ srcExists=1
+fi
+docker-php-source extract
+if [ -z "$srcExists" ]; then
+ touch /usr/src/php/.docker-delete-me
+fi
+
+cd /usr/src/php/ext
+
+ext="$1"
+if [ -z "$ext" ] || [ ! -d "$ext" ]; then
+ echo >&2 "usage: $0 ext-name [configure flags]"
+ echo >&2 " ie: $0 gd --with-jpeg-dir=/usr/local/something"
+ echo >&2
+ echo >&2 'Possible values for ext-name:'
+ find /usr/src/php/ext \
+ -mindepth 2 \
+ -maxdepth 2 \
+ -type f \
+ -name 'config.m4' \
+ | xargs -n1 dirname \
+ | xargs -n1 basename \
+ | sort \
+ | xargs
+ exit 1
+fi
+shift
+
+pm='unknown'
+if [ -e /lib/apk/db/installed ]; then
+ pm='apk'
+fi
+
+if [ "$pm" = 'apk' ]; then
+ if \
+ [ -n "$PHPIZE_DEPS" ] \
+ && ! apk info --installed .phpize-deps > /dev/null \
+ && ! apk info --installed .phpize-deps-configure > /dev/null \
+ ; then
+ apk add --no-cache --virtual .phpize-deps-configure $PHPIZE_DEPS
+ fi
+fi
+
+if command -v dpkg-architecture > /dev/null; then
+ gnuArch="$(dpkg-architecture --query DEB_BUILD_GNU_TYPE)"
+ set -- --build="$gnuArch" "$@"
+fi
+
+set -x
+cd "$ext"
+phpize
+./configure "$@"
diff --git a/5.3/fpm/alpine/docker-php-ext-enable b/5.3/fpm/alpine/docker-php-ext-enable
new file mode 100755
index 000000000..0acb79df7
--- /dev/null
+++ b/5.3/fpm/alpine/docker-php-ext-enable
@@ -0,0 +1,104 @@
+#!/bin/sh
+set -e
+
+cd "$(php -r 'echo ini_get("extension_dir");')"
+
+usage() {
+ echo "usage: $0 [options] module-name [module-name ...]"
+ echo " ie: $0 gd mysqli"
+ echo " $0 pdo pdo_mysql"
+ echo " $0 --ini-name 0-apc.ini apcu apc"
+ echo
+ echo 'Possible values for module-name:'
+ echo $(find -maxdepth 1 -type f -name '*.so' -exec basename '{}' ';' | sort)
+}
+
+opts="$(getopt -o 'h?' --long 'help,ini-name:' -- "$@" || { usage >&2 && false; })"
+eval set -- "$opts"
+
+iniName=
+while true; do
+ flag="$1"
+ shift
+ case "$flag" in
+ --help|-h|'-?') usage && exit 0 ;;
+ --ini-name) iniName="$1" && shift ;;
+ --) break ;;
+ *)
+ {
+ echo "error: unknown flag: $flag"
+ usage
+ } >&2
+ exit 1
+ ;;
+ esac
+done
+
+modules=
+for module; do
+ if [ -z "$module" ]; then
+ continue
+ fi
+ if [ -f "$module.so" ] && ! [ -f "$module" ]; then
+ # allow ".so" to be optional
+ module="$module.so"
+ fi
+ if ! [ -f "$module" ]; then
+ echo >&2 "error: $(readlink -f "$module") does not exist"
+ echo >&2
+ usage >&2
+ exit 1
+ fi
+ modules="$modules $module"
+done
+
+if [ -z "$modules" ]; then
+ usage >&2
+ exit 1
+fi
+
+pm='unknown'
+if [ -e /lib/apk/db/installed ]; then
+ pm='apk'
+fi
+
+apkDel=
+if [ "$pm" = 'apk' ]; then
+ if \
+ [ -n "$PHPIZE_DEPS" ] \
+ && ! apk info --installed .phpize-deps > /dev/null \
+ && ! apk info --installed .phpize-deps-configure > /dev/null \
+ ; then
+ apk add --no-cache --virtual '.docker-php-ext-enable-deps' binutils
+ apkDel='.docker-php-ext-enable-deps'
+ fi
+fi
+
+for module in $modules; do
+ if nm -g "$module" | grep -q ' zend_extension_entry$'; then
+ # https://wiki.php.net/internals/extensions#loading_zend_extensions
+ line="zend_extension=$(readlink -f "$module")"
+ else
+ line="extension=$module"
+ fi
+
+ ext="$(basename "$module")"
+ ext="${ext%.*}"
+ if php -r 'exit(extension_loaded("'"$ext"'") ? 0 : 1);'; then
+ # this isn't perfect, but it's better than nothing
+ # (for example, 'opcache.so' presents inside PHP as 'Zend OPcache', not 'opcache')
+ echo >&2
+ echo >&2 "warning: $ext ($module) is already loaded!"
+ echo >&2
+ continue
+ fi
+
+ ini="/usr/local/etc/php/conf.d/${iniName:-"docker-php-ext-$ext.ini"}"
+ if ! grep -q "$line" "$ini" 2>/dev/null; then
+ echo "$line" >> "$ini"
+ fi
+done
+
+if [ "$pm" = 'apk' ] && [ -n "$apkDel" ]; then
+ apk del $apkDel
+fi
diff --git a/5.3/fpm/alpine/docker-php-ext-install b/5.3/fpm/alpine/docker-php-ext-install
new file mode 100755
index 000000000..c06602302
--- /dev/null
+++ b/5.3/fpm/alpine/docker-php-ext-install
@@ -0,0 +1,119 @@
+#!/bin/sh
+set -e
+
+# prefer user supplied CFLAGS, but default to our PHP_CFLAGS
+: ${CFLAGS:=$PHP_CFLAGS}
+: ${CPPFLAGS:=$PHP_CPPFLAGS}
+: ${LDFLAGS:=$PHP_LDFLAGS}
+export CFLAGS CPPFLAGS LDFLAGS
+
+srcExists=
+if [ -d /usr/src/php ]; then
+ srcExists=1
+fi
+docker-php-source extract
+if [ -z "$srcExists" ]; then
+ touch /usr/src/php/.docker-delete-me
+fi
+
+cd /usr/src/php/ext
+
+usage() {
+ echo "usage: $0 [-jN] ext-name [ext-name ...]"
+ echo " ie: $0 gd mysqli"
+ echo " $0 pdo pdo_mysql"
+ echo " $0 -j5 gd mbstring mysqli pdo pdo_mysql shmop"
+ echo
+ echo 'if custom ./configure arguments are necessary, see docker-php-ext-configure'
+ echo
+ echo 'Possible values for ext-name:'
+ find . \
+ -mindepth 2 \
+ -maxdepth 2 \
+ -type f \
+ -name 'config.m4' \
+ | xargs -n1 dirname \
+ | xargs -n1 basename \
+ | sort \
+ | xargs
+}
+
+opts="$(getopt -o 'h?j:' --long 'help,jobs:' -- "$@" || { usage >&2 && false; })"
+eval set -- "$opts"
+
+j=1
+while true; do
+ flag="$1"
+ shift
+ case "$flag" in
+ --help|-h|'-?') usage && exit 0 ;;
+ --jobs|-j) j="$1" && shift ;;
+ --) break ;;
+ *)
+ {
+ echo "error: unknown flag: $flag"
+ usage
+ } >&2
+ exit 1
+ ;;
+ esac
+done
+
+exts=
+for ext; do
+ if [ -z "$ext" ]; then
+ continue
+ fi
+ if [ ! -d "$ext" ]; then
+ echo >&2 "error: $PWD/$ext does not exist"
+ echo >&2
+ usage >&2
+ exit 1
+ fi
+ exts="$exts $ext"
+done
+
+if [ -z "$exts" ]; then
+ usage >&2
+ exit 1
+fi
+
+pm='unknown'
+if [ -e /lib/apk/db/installed ]; then
+ pm='apk'
+fi
+
+apkDel=
+if [ "$pm" = 'apk' ]; then
+ if [ -n "$PHPIZE_DEPS" ]; then
+ if apk info --installed .phpize-deps-configure > /dev/null; then
+ apkDel='.phpize-deps-configure'
+ elif ! apk info --installed .phpize-deps > /dev/null; then
+ apk add --no-cache --virtual .phpize-deps $PHPIZE_DEPS
+ apkDel='.phpize-deps'
+ fi
+ fi
+fi
+
+popDir="$PWD"
+for ext in $exts; do
+ cd "$ext"
+ [ -e Makefile ] || docker-php-ext-configure "$ext"
+ make -j"$j"
+ make -j"$j" install
+ find modules \
+ -maxdepth 1 \
+ -name '*.so' \
+ -exec basename '{}' ';' \
+ | xargs -r docker-php-ext-enable
+ make -j"$j" clean
+ cd "$popDir"
+done
+
+if [ "$pm" = 'apk' ] && [ -n "$apkDel" ]; then
+ apk del $apkDel
+fi
+
+if [ -e /usr/src/php/.docker-delete-me ]; then
+ docker-php-source delete
+fi
diff --git a/5.3/fpm/alpine/docker-php-source b/5.3/fpm/alpine/docker-php-source
new file mode 100755
index 000000000..9033d243d
--- /dev/null
+++ b/5.3/fpm/alpine/docker-php-source
@@ -0,0 +1,34 @@
+#!/bin/sh
+set -e
+
+dir=/usr/src/php
+
+usage() {
+ echo "usage: $0 COMMAND"
+ echo
+ echo "Manage php source tarball lifecycle."
+ echo
+ echo "Commands:"
+ echo " extract extract php source tarball into directory $dir if not already done."
+ echo " delete delete extracted php source located into $dir if not already done."
+ echo
+}
+
+case "$1" in
+ extract)
+ mkdir -p "$dir"
+ if [ ! -f "$dir/.docker-extracted" ]; then
+ tar -Jxf /usr/src/php.tar.xz -C "$dir" --strip-components=1
+ touch "$dir/.docker-extracted"
+ fi
+ ;;
+
+ delete)
+ rm -rf "$dir"
+ ;;
+
+ *)
+ usage
+ exit 1
+ ;;
+esac